#pragma once
#include "messagebasic.h"

/// <summary>
/// ָ·ģʽ
/// </summary>
enum class NavigateDriveMode {
	Cruise,	// Ѳģʽ;Ϯģʽ
	FullSpeed,// ȫģʽս
	ReachStop,	// ͣפģʽ
};
/// <summary>
/// ָ·
/// </summary>
struct MESSAGEBASIC_EXPORT NavigateWithRoute : public AbstractMessage {
	QString _route_name;	// 滮
	NavigateDriveMode _drive_mode;	// ģʽ

	NavigateWithRoute();

	// Serializable
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ƽ̨ϵΪYΪXΪZ
/// </summary>
struct MESSAGEBASIC_EXPORT PlatformMotionCommand : public AbstractMessage {
	PlatformMotionCommand(const QString &nm);

	/// <summary>
	/// ʱ
	/// </summary>
	/// <returns></returns>
	virtual double timeExpend() const = 0;
	/// <summary>
	/// ָʱλ
	/// </summary>
	/// <param name="time"></param>
	/// <returns>ϵ</returns>
	virtual QVector3D posAtTime(double time) const = 0;
	/// <summary>
	/// ָʱٶʸ
	/// </summary>
	/// <param name="time"></param>
	/// <returns>ϵ</returns>
	virtual QVector3D speedAtTime(double time) const = 0;
};

/// <summary>
/// 鿴ָĿʵĻָ
/// </summary>
struct MESSAGEBASIC_EXPORT MotionSequencePreviewGet : public AbstractMessage {
	MotionSequencePreviewGet();
};

/// <summary>
/// ƽ̨
/// </summary>
struct MESSAGEBASIC_EXPORT PlatformMotionSequence : public AbstractMessage {
	QList<std::shared_ptr<PlatformMotionCommand>> _cmd_sequence;

	PlatformMotionSequence();

	// Serializable
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};


// ʵ =======================================================

/// <summary>
/// ֱ߻
/// </summary>
struct MESSAGEBASIC_EXPORT StrightLineMotion : public PlatformMotionCommand {
	/// <summary>
	/// ٶȣm/s
	/// </summary>
	double _speed_motion = 0;
	/// <summary>
	/// ٶȣm/s^2
	/// </summary>
	double _accerlate_rates = 0;
	/// <summary>
	/// ·
	/// </summary>
	double _length_total = 0;

	StrightLineMotion();

	double timeExpend() const override;
	QVector3D posAtTime(double time) const override;
	QVector3D speedAtTime(double time) const override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

#include <QVector3D>
/// <summary>
/// ڻϵˮƽ׼Բ
/// </summary>
struct MESSAGEBASIC_EXPORT HorizontalArcMotion : public PlatformMotionCommand {
	/// <summary>
	/// תԲ,<xpos, ypos, 0>
	/// </summary>
	QVector3D _center_point;
	/// <summary>
	/// תǣ
	/// </summary>
	double _rotate_deg = 0;
	/// <summary>
	/// ٶȣm/s
	/// </summary>
	double _speed_motion = 0;

	HorizontalArcMotion();

	double timeExpend() const override;
	QVector3D posAtTime(double time) const override;
	QVector3D speedAtTime(double time) const override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ڻϵĴֱ׼Բ
/// </summary>
struct MESSAGEBASIC_EXPORT VerticalArcMotion : public PlatformMotionCommand {
	/// <summary>
	/// תԲ,<0, ypos, zpos>
	/// </summary>
	QVector3D _center_point;
	/// <summary>
	/// תǣ
	/// </summary>
	double _rotate_deg = 0;
	/// <summary>
	/// ٶȣm/s
	/// </summary>
	double _speed_motion = 0;

	VerticalArcMotion();

	double timeExpend() const override;
	QVector3D posAtTime(double time) const override;
	QVector3D speedAtTime(double time) const override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};